SystemOrganization addCategory: #ExtentionsForKendrick!

Error subclass: #KendrickDSLSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

Object subclass: #MeaslesScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!MeaslesScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 18:09'!
run

Kendrick model
	id: 'Measles';
	population: 1000;
	status: #(S E I R); 
	S: 99999;
	I: 1;
	others: 0;
	beta: 0.0000214;
	gamma: 0.143;
	mu: 0.000351;
	sigma: 0.125;
	equations: #(
		S(t) = mu*N - beta*S*I - mu*S;
		E(t) = beta*S*I - sigma*E - mu*E;
		I(t) = sigma*E - gamma*I - mu*I;
		R(t) = gamma*I - mu*R;
	).
	
Simulation rungeKutta
	id: 'RKSim';
	for: 'Measles';
	from: 0.0; 
	to: 150; 
	step: 1.
	
Visualization diagram 
	id: 'DiagramViz';
	for: 'RKSim';
	xLabel: 'Time (days)'.! !

ProtoObject subclass: #KendrickInternalDSLKeywords
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

KendrickInternalDSLKeywords subclass: #Kendrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Kendrick class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:44'!
model

	^ KendrickModel new! !

Kendrick subclass: #KendrickEquations
	instanceVariableNames: 'eqAsSymExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:58'!
parseToCompatibleStrings! !

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:57'!
with: symExpression

	eqAsSymExpr := symExpression ! !

Kendrick subclass: #KendrickModel
	instanceVariableNames: 'population attributes parameters equations keModel explicitelySetCompartments otherCompartmentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:33'!
atCompartment: variable value: value

	|assoc|

	assoc := (attributes associations select: [ :as | as value includes: variable ]) first.
	keModel at: { assoc key -> assoc value } put: value.! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:28'!
attributeValuesIncludes: variable

	^ (attributes values select: [ :values | values includes: variable ]) isEmpty not! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:40'!
doesNotUnderstand: aMessage

	|variable value|
	
	variable := aMessage selector.
	value := aMessage args first.

	value isNumber 
		ifTrue: [   
			(self attributeValuesIncludes: variable)
				ifTrue: [ 
					explicitelySetCompartments add: variable.
					self atCompartment: variable value: value. 
				]
				ifFalse: [ 
					parameters at: variable put: value.
					keModel addParameter: variable value: value 
				]
		] ifFalse: [  
			value isArray
				ifTrue: [ 
					attributes at: variable put: value.
					keModel addAttribute: variable value: value  
				]
				ifFalse: [ KendrickDSLSyntaxError signal: 'Expected a Number or Array got: ' , value asString , ' instead'. ]	
		]
	
	! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 18:01'!
equations: anArrayOfSymExpressions

	equations :=
		KendrickEquations new with: anArrayOfSymExpressions.
	keModel addEquations: equations parseToCompatibleStrings.
	! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:41'!
initialize

	keModel := KEModel new.
	attributes := Dictionary new.
	parameters := Dictionary new.
	explicitelySetCompartments := OrderedCollection new.! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:42'!
others: anInteger

	otherCompartmentValue := anInteger.

	keModel initCompartments
		keysDo: [ :k | 
			(explicitelySetCompartments includes: k)
				ifFalse: [ self atCompartment: k put: anInteger ] 
		]! !

!KendrickModel methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:44'!
population: anInteger

	keModel population: (KEPopulation size: 100000).! !

!KendrickInternalDSLKeywords class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:53'!
withId: anId

	^ self allInstances select: [ :instance | instance id = anId ]! !

!KendrickInternalDSLKeywords methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:51'!
id

	^ id! !

!KendrickInternalDSLKeywords methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:52'!
id: aString

	id := aString! !

KendrickInternalDSLKeywords subclass: #Simulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

KendrickInternalDSLKeywords subclass: #Visualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!
